'use strict';

require('./global-slimmer-registry-7bbdb1f2.js');
const createPublicApiRuntimeMetricsSlimmer = require('./create-public-api-runtime-metrics-slimmer-1b8ecfb4.js');
const internalVegaZIndexManager = require('./internal-vega-z-index-manager-18805137.js');
require('./dynamic-slimmer-0050c489.js');
require('./misc-3d30df91.js');
require('./number-4816603d.js');

const ZIndexManagerRuntimeMetricsPayloadDefinition = [
  {
    payloadKey: 'IS_OVERRIDEZINDEXBASICVALUES_METHOD_CALLED',
    payloadDescription: 'Indicate if the method overrideZIndexBasicValues of public API ZIndexManager is called',
    /**
     * Indicate whether the method is collected when the method been called .
     *
     * @param {string} scope - The class name of public api
     * @param {string} methodName - The method name called by the public api
     * @returns {boolean} A boolean value
     */
    canAccept: (scope, methodName) => scope === 'VegaZIndexManager' && methodName === 'overrideZIndexBasicValues',
    /**
     * The function checks if the method name is load.
     *
     * @returns {boolean} A boolean value
     */
    payloadValue: () => {
      return true;
    },
  },
  {
    payloadKey: 'zIndexBasicValuesGreatThanTenThousand',
    payloadDescription: 'Indicate if the basic z-index value is great than ten thousand',
    /**
     * Indicate whether the method is collected when the method been called .
     *
     * @param {string} scope - The class name of public api
     * @param {string} methodName - The method name called by the public api
     * @returns {boolean} A boolean value
     */
    canAccept: (scope, methodName) => scope === 'VegaZIndexManager' && methodName === 'overrideZIndexBasicValues',
    /**
     * The function checks if the method name is load.
     *
     * @param {unknown[]} args - The parameter of slimmer method
     * @returns {boolean} A boolean value
     */
    payloadValue: (args) => {
      return args['base'] > 10000;
    },
  },
];

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
/**
 * The VegaZIndexManager class calls a method in the ZIndexManager class to
 * change z-index values based on the input.
 */
class VegaZIndexManager {
  constructor() {
    this.vegaPublicAPIRuntimeMetricsSlimmer = createPublicApiRuntimeMetricsSlimmer.createPublicAPIRuntimeMetricsSlimmer(VegaZIndexManager, ['overrideZIndexBasicValues'], ZIndexManagerRuntimeMetricsPayloadDefinition);
  }
  /**
   * The function "overrideZIndexBasicValues" calls a method in the "ZIndexManager" class to change the
   * z-index values based on the input.
   *
   * @param {ZIndexBasicValues} input - The input parameter is of type ZIndexBasicValues.
   * @vegaVersion 2.3.0
   */
  overrideZIndexBasicValues(input) {
    internalVegaZIndexManager.InternalVegaZIndexManager.overrideZIndexBasicValues(input);
  }
}
__decorate([
  createPublicApiRuntimeMetricsSlimmer.InjectVegaTelemetrySlimmer()
], VegaZIndexManager.prototype, "vegaPublicAPIRuntimeMetricsSlimmer", void 0);
const VegaZIndexManager$1 = new VegaZIndexManager();

exports.default = VegaZIndexManager$1;
